image: registry.gitlab.com/partisia/dockerimages/rust:1.84

stages:
- build
- pre-publish
- publish

build:
  stage: build
  script:
  - |
    mkdir -p "$CI_PROJECT_DIR/build_output"
    cargo build --target x86_64-unknown-linux-gnu --release
    find target/release -maxdepth 1 -type f -exec mv \{\} "$CI_PROJECT_DIR/build_output" \;

codequality-test:
  stage: build
  dependencies:
  - run-test
  except:
  - main
  script:
  - cargo check
  - cargo clippy --all-targets --all-features -- -D warnings -D missing_docs
  - cargo fmt --all -- --check

run-test:
  image: registry.gitlab.com/partisia/dockerimages/rustmaven:1.84
  stage: build
  except:
  - main
  script:
  - CARGO_INCREMENTAL=0 cargo test -- --nocapture

docs:
  stage: build
  script:
  - cargo clippy --all-targets --all-features -- -D missing_docs -D warnings

publish-dry-run:
  stage: pre-publish
  script:
  - cargo publish --dry-run

publish:
  stage: publish
  script:
  - echo "$CI_COMMIT_TAG"
  - cargo publish
  rules:
  - if: $CI_COMMIT_TAG
